## chromium 141.0.7390.107~linuxmint1+faye

=== debian/changelog ===
chromium (141.0.7390.107~linuxmint1+faye) unstable; urgency=medium

  * 141.0.7390.107

 -- Linux Mint <root@linuxmint.com>  Tue, 14 Oct 2025 21:20:18 +0100

chromium (141.0.7390.76~linuxmint1) unstable; urgency=medium

  * 141.0.7390.76

 -- Linux Mint <root@linuxmint.com>  Thu, 09 Oct 2025 21:36:17 +0100

chromium (141.0.7390.65~linuxmint1) unstable; urgency=medium

  * 141.0.7390.65

 -- Linux Mint <root@linuxmint.com>  Tue, 07 Oct 2025 20:50:17 +0100

chromium (141.0.7390.54~linuxmint1) unstable; urgency=medium

  * 141.0.7390.54

 -- Linux Mint <root@linuxmint.com>  Tue, 30 Sep 2025 21:19:32 +0100

## chromium 141.0.7390.107~linuxmint1+gigi

=== debian/changelog ===
chromium (141.0.7390.107~linuxmint1+gigi) unstable; urgency=medium

  * 141.0.7390.107

 -- Linux Mint <root@linuxmint.com>  Tue, 14 Oct 2025 21:20:18 +0100

## chromium 141.0.7390.107~linuxmint1+virginia

=== debian/changelog ===
chromium (141.0.7390.107~linuxmint1+virginia) unstable; urgency=medium

  * 141.0.7390.107

 -- Linux Mint <root@linuxmint.com>  Tue, 14 Oct 2025 21:20:18 +0100

## chromium 141.0.7390.107~linuxmint1+zara

=== debian/changelog ===
chromium (141.0.7390.107~linuxmint1+zara) unstable; urgency=medium

  * 141.0.7390.107

 -- Linux Mint <root@linuxmint.com>  Tue, 14 Oct 2025 21:20:18 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    PAR := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
    PAR := "1"
endif

DEB_VERSION=$(shell dpkg-parsechangelog | sed -n 's/^Version: //p')

%:
	dh  ${@}

override_dh_auto_configure:
	$(CURDIR)/prep $(CURDIR) $(DEB_VERSION)

override_dh_prep:

override_dh_auto_build:
	$(CURDIR)/build $(CURDIR) $(DEB_VERSION) $(PAR)

override_dh_auto_install:
	dh_install

override_dh_strip:
	dh_strip --dbg-package=chromium-dbg

override_dh_dwz:

## chromium 141.0.7390.107

=== build/android/tests/symbolize/Makefile ===
# Copyright 2013 The Chromium Authors
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

TOOLCHAIN=../../../../third_party/android_toolchain/ndk/toolchains/arm-linux-androideabi-4.6/prebuilt/linux-x86_64/bin/arm-linux-androideabi-
CXX=$(TOOLCHAIN)g++

lib%.so: %.cc
	$(CXX) -nostdlib -g -fPIC -shared $< -o $@

all: liba.so libb.so

=== debian/changelog ===
chromium (141.0.7390.107-1~deb13u1) trixie-security; urgency=high

  * New upstream security release.
    - CVE-2025-11756: Use after free in Safe Browsing. Reported by asnine.
  * Suggest --disable-gpu to bug reporters and in README.Debian.

 -- Andres Salomon <dilinger@debian.org>  Tue, 14 Oct 2025 19:25:54 -0400

=== debian/rules ===
#!/usr/bin/make -f

# enable verbose build messages
export DH_VERBOSE=1

# indicate that binary targets do not require root
export DEB_RULES_REQUIRES_ROOT=no

-include /usr/share/dpkg/architecture.mk

ifeq (armhf,$(DEB_HOST_ARCH))
# avoid "argument unused during compilation" warnings on armhf
arg_hardening = +all,-stackclash
else
# enable all build hardening flags
arg_hardening = +all
endif
export DEB_BUILD_MAINT_OPTIONS=hardening=$(arg_hardening)

# disable lto flags, go with use_thin_lto instead
export DEB_BUILD_MAINT_OPTIONS+=optimize=-lto

# cross-build support
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
ifeq ($(filter cross,$(DEB_BUILD_PROFILES)),)
$(error Please specify the "cross" build profile)
endif
export DEB_BUILD_OPTIONS+=crossbuildcanrunhostbinaries
export HOST_EXEC_WRAPPER=$(DEB_HOST_GNU_TYPE)-cross-exe-wrapper
cross_pkg_config=$(DEB_HOST_GNU_TYPE)-pkgconf
endif

# compile with clang (gcc is currently not supported)
export AR=ar
export NM=nm
export CC=clang-19
export CXX=clang++-19

# initial flags from dpkg-buildflags
export DEB_CXXFLAGS_MAINT_STRIP=-g
export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) -stdlib=libc++
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -stdlib=libc++ -static-libstdc++

# more verbose linker output
export LDFLAGS+=-Wl,--stats

# extra flags to reduce warnings that aren't very useful
export CXXFLAGS+=-Wno-conversion \
                 -Wno-unused-function \
                 -Wno-unused-variable \
                 -Wno-unused-private-field \
                 -Wno-deprecated-declarations \
                 -Wno-unknown-pragmas \

# do not optimize away null pointer safety checks
export CXXFLAGS+=-fno-delete-null-pointer-checks

ifeq (ppc64el,$(DEB_HOST_ARCH))
# avoid altivec incompatibilities / deprecation warnings
export CXXFLAGS+=-faltivec-src-compat=mixed -Wno-deprecated-altivec-src-compat
endif

# disable clang plugins
defines:=clang_use_chrome_plugins=false

# use system rust
export RUSTC_BOOTSTRAP=1
export CLANG_MVERS:=$(shell $(CC) --version 2>/dev/null | sed -n 's/.* clang version //p' | cut -d. -f1)
rust_sysroot=/usr
defines+=rust_sysroot_absolute=\"$(rust_sysroot)\"
defines+=rust_bindgen_root=\"/usr\"
defines+=rustc_version=\"$(shell $(rust_sysroot)/bin/rustc --version 2>/dev/null)\"
defines+=clang_base_path=\"/usr/lib/llvm-$(CLANG_MVERS)\"
defines+=clang_version=\"$(CLANG_MVERS)\"

# build using system toolchain
defines+=host_toolchain=\"//build/toolchain/linux/unbundle:default\"
defines+=custom_toolchain=\"//build/toolchain/linux/unbundle:default\"

# set the appropriate cpu architecture
DEB_HOST_ARCH_value := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH ?= $(DEB_HOST_ARCH_value)
ifeq (i386,$(DEB_HOST_ARCH))
defines+=host_cpu=\"x86\" use_vaapi=true
endif
ifeq (amd64,$(DEB_HOST_ARCH))
defines+=host_cpu=\"x64\" use_vaapi=true
endif
ifeq (arm64,$(DEB_HOST_ARCH))
defines+=host_cpu=\"arm64\" use_v4l2_codec=true use_vaapi=false
endif
ifeq (armhf,$(DEB_HOST_ARCH))
defines+=host_cpu=\"arm\" use_v4l2_codec=true use_vaapi=false arm_use_neon=true
endif
ifeq (ppc64el,$(DEB_HOST_ARCH))
defines+=host_cpu=\"ppc64\" use_vaapi=true
endif

ifdef cross_pkg_config
defines+=pkg_config=\"$(cross_pkg_config)\"
endif

# thin lto requires >4 GB RAM, so avoid it on 32-bit build hosts
ifeq (32,$(DEB_BUILD_ARCH_BITS))
defines+=use_thin_lto=false \
         concurrent_links=1
else
defines+=use_thin_lto=true
endif

# disabled features
defines+=is_debug=false \
         use_sysroot=false \
         use_libjpeg_turbo=true \
         use_custom_libcxx=false \
         optimize_webui=false \
         use_unofficial_version_number=false \
         safe_browsing_use_unrar=false \
         enable_vr=false \
         enable_enterprise_companion=false \
         enable_glic=false \
         build_dawn_tests=false \
         enable_iterator_debugging=false \
         enable_hangout_services_extension=false \
         angle_has_histograms=false \
         angle_build_tests=false \
         build_angle_perftests=false \
         treat_warnings_as_errors=false \
         clang_warning_suppression_file=\"\" \
         use_qt5=false use_qt6=false \
         is_cfi=false \
         chrome_pgo_phase=0 \

# enabled features
defines+=use_gio=true \
         is_official_build=true \
         symbol_level=0 \
         use_pulseaudio=true \
         link_pulseaudio=true \
         rtc_use_pipewire=true \
         icu_use_data_file=true \
         enable_widevine=true \
         v8_enable_backtrace=true \
         use_system_zlib=true \
         use_system_lcms2=true \
         use_system_libjpeg=true \
         use_system_libpng=true \
         use_system_libtiff=false \
         use_system_freetype=true \
         use_system_harfbuzz=true \
         use_system_libopenjpeg2=true \
         proprietary_codecs=true \
         ffmpeg_branding=\"Chrome\" \
         disable_fieldtrial_testing_config=true \

# handle parallel build options
njobs=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
njobs=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

DIST := $(shell dpkg-parsechangelog -l debian/changelog  | sed -n 's/^Distribution: //p')

%:
	dh $@


# don't build armhf on build systems that lack NEON
test_armhf_neon:
	uname -m
	if [ `uname -m` = "armv7l" ]; then \
		grep -q 'neon\|asimd' /proc/cpuinfo || { \
			echo "No NEON extension detected on armhf, refusing to build" 1>&2; \
			false; \
		}; \
	fi

override_dh_auto_configure: test_armhf_neon
	# verify that we're not accidentally uploading to stable-security without CVEs
	@echo "$(DIST)" | grep -q -- '-security' && { \
		dpkg-parsechangelog -l debian/changelog | grep -q 'CVE-' || { \
			echo "ERROR: security upload with no CVEs listed. You should fix that."; \
			exit 1; \
		} \
	} || true
	# use system node w/out patching source; upstream hardcodes x64 in path
	mkdir -p third_party/node/linux/node-linux-x64/bin
	cp /usr/bin/node third_party/node/linux/node-linux-x64/bin
	# use system rollup
	cp -ra /usr/share/nodejs/rollup third_party/node/node_modules/
	- test -L third_party/devtools-frontend/src/node_modules/rollup3 || ln -s /usr/share/nodejs/rollup third_party/devtools-frontend/src/node_modules/rollup3
	# output compiler information
	$(CXX) --version
	# prefer unbundled (system) libraries
	./debian/scripts/unbundle

override_dh_auto_build-arch:
	gn gen out/Release --args="$(defines)"
	ninja -j$(njobs) -C out/Release chrome chrome_sandbox content_shell chromedriver headless_shell
	cp out/Release/chrome out/Release/chromium
	cp out/Release/content_shell out/Release/chromium-shell
	cp out/Release/headless_shell out/Release/chromium-headless-shell
	cp out/Release/chrome_sandbox out/Release/chrome-sandbox
	cp out/Release/locales/en-US.pak out/Release/resources
	chmod 4755 out/Release/chrome-sandbox # suid sandbox
	sed -e s/@@PACKAGE@@/chromium/g -e s/@@MENUNAME@@/chromium/g \
	    < chrome/app/resources/manpage.1.in > out/Release/chromium.1

override_dh_auto_build-indep:
	gn gen out/Release --args="$(defines)"
	ninja -j$(njobs) -C out/Release packed_resources
	rm -f out/Release/locales/en-US.pak

override_dh_auto_install-arch:
	dh_auto_install
	# update launcher script with build information
	sed 's|@BUILD_DIST@|$(shell . /etc/os-release && echo "$$PRETTY_NAME")|' \
	    < debian/scripts/chromium > debian/chromium/usr/bin/chromium
	# move icons into /usr/share
	./debian/scripts/icons

override_dh_fixperms:
	dh_fixperms --exclude chrome-sandbox

override_dh_auto_clean:
	rm -rf third_party/node/linux/node-linux-x64
	rm -rf out
	rm -rf third_party/node/node_modules/rollup
	rm -f third_party/devtools-frontend/src/node_modules/rollup3
	# bullseye workarounds; delete this post-bullseye
	rm -rf third_party/node/node_modules/acorn
	rm -rf third_party/node/node_modules/walk
	find . -name \*.pyc -execdir rm -f {} \;
	dh_auto_clean

###################### upstream source downloading ############################

ifdef FROM_GOOGLE
# official distribution server

## chromium 141.0.7390.122

=== debian/changelog ===
chromium (141.0.7390.122-1~deb13u1) trixie-security; urgency=high

  * New upstream security release.
    - CVE-2025-12036: Inappropriate implementation in V8.
      Reported by Google Big Sleep.

 -- Andres Salomon <dilinger@debian.org>  Tue, 21 Oct 2025 22:21:26 -0400

## chromium 142.0.7444.59~linuxmint1%2Bgigi

=== debian/changelog ===
chromium (142.0.7444.59~linuxmint1+gigi) unstable; urgency=medium

  * 142.0.7444.59

 -- Linux Mint <root@linuxmint.com>  Tue, 28 Oct 2025 21:35:17 +0000

chromium (141.0.7390.122~linuxmint1) unstable; urgency=medium

  * 141.0.7390.122

 -- Linux Mint <root@linuxmint.com>  Tue, 21 Oct 2025 20:20:16 +0100

chromium (141.0.7390.107~linuxmint1) unstable; urgency=medium

  * 141.0.7390.107

 -- Linux Mint <root@linuxmint.com>  Tue, 14 Oct 2025 21:20:18 +0100

## chromium 142.0.7444.59~linuxmint1+faye

=== debian/changelog ===
chromium (142.0.7444.59~linuxmint1+faye) unstable; urgency=medium

  * 142.0.7444.59

 -- Linux Mint <root@linuxmint.com>  Tue, 28 Oct 2025 21:35:17 +0000

## chromium 142.0.7444.59~linuxmint1+virginia

=== debian/changelog ===
chromium (142.0.7444.59~linuxmint1+virginia) unstable; urgency=medium

  * 142.0.7444.59

 -- Linux Mint <root@linuxmint.com>  Tue, 28 Oct 2025 21:35:17 +0000

=== debian/control ===
Source: chromium
Section: web
Priority: optional
Maintainer: Clement Lefebvre <root@linuxmint.com>
Standards-Version: 3.9.5
Build-Depends:
    debhelper (>= 9),
    quilt,
    wget,
    make,
    g++,
    autoconf,
    automake,
    ninja-build,
    python3-pkgconfig,
    lsb-release,
    python3,
    bison,
    flex,
    gawk,
    git,
    gperf,
    subversion,
    cmake,
    sed,
    gzip,
    default-jre-headless,
    libxml2-dev,
    libpulse-dev,
    libcups2-dev,
    libasound2-dev,
    libnss3-dev,
    mesa-common-dev,
    libgles2-mesa-dev,
    libpci-dev,
    libxtst-dev,
    libxss-dev,
    qtbase5-dev,
    libgtk-3-dev,
    libglib2.0-dev,
    libudev-dev,
    libdrm-dev,
    libcap-dev,
    libgcrypt-dev,
    libkrb5-dev,
    libxkbcommon-dev,
    libpam0g-dev,
    libffi-dev,
    libgbm-dev,
    xcb-proto,
    uuid-dev,
    chrpath,
    yasm,
    libglib2.0-bin,
    shared-mime-info,
    zlib1g-dev,
    libx11-xcb-dev,
    libxcb-dri3-dev,
    libtinfo5,
    libxshmfence-dev,
    libcurl4-openssl-dev,
    libevdev-dev,
    libssl-dev,
    elfutils,
    nodejs

Package: chromium
Architecture: any
Depends:
    python3 (>= 3.3),
    perl,
    libgbm1,
    libgl1,
    libglx-mesa0,
    libgtk-3-0,
    libnss3,
    libsecret-1-0,
    libxss1,
    shared-mime-info,
    libxshmfence1,
    ${misc:Depends}
Provides:
    chromium-codecs-ffmpeg,
    chromium-codecs-ffmpeg-extra,
Breaks:
#     debian/buster
    chromium-common,
    chromium-l10n,
    chromium-driver,
    chromium-sandbox,
    chromium-shell,
#     ubuntu 18.04
    chromium-browser-l10n,
    chromium-chromedriver,
    chromium-codecs-ffmpeg,
    chromium-codecs-ffmpeg-extra,
Replaces:
#     debian/buster
    chromium-common,
    chromium-l10n,
    chromium-driver,
    chromium-sandbox,
    chromium-shell,
#     ubuntu 18.04
    chromium-browser-l10n,
    chromium-chromedriver,
    chromium-codecs-ffmpeg,
    chromium-codecs-ffmpeg-extra,
Description: web browser
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains the web browser component.

Package: chromium-dbg
Section: debug
Architecture: any
Priority: extra
Depends: chromium (= ${binary:Version}), ${misc:Depends}
Breaks:
#     debian/buster
    chromium-dbgsym,
#     ubuntu 18.04
    chromium-browser-dbgsym,
    chromium-chromedriver-dbgsym,
Replaces:
#     debian/buster
    chromium-dbgsym,
#     ubuntu 18.04
    chromium-browser-dbgsym,
    chromium-chromedriver-dbgsym,
Description: web browser
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains debugging symbols.

## chromium 142.0.7444.59~linuxmint1+zara

=== debian/changelog ===
chromium (142.0.7444.59~linuxmint1+zara) unstable; urgency=medium

  * 142.0.7444.59

 -- Linux Mint <root@linuxmint.com>  Tue, 28 Oct 2025 21:35:17 +0000

## chromium 142.0.7444.59

=== debian/changelog ===
chromium (1:142.0.7444.59-1~deb13u1+rpt1) trixie; urgency=medium

  [ Serge Schneider ]
  * Import PiOS patches from Bookworm
  * Remove debian patches duplicated by PiOS
  * d/c: Remove system-config-printer from recommends
  * Launcher: Add a low memory check and switch to zenoty for dialogs
  * Launcher: extend NEON check to armv6l platforms
  * Work around tabs crashing when using a 16k page size kernel
  * Add --use-angle=gles unless --no-gl-override is specified
  * Bump alternatives priority to 90
  * d/r: Use DEB_VERSION_UPSTREAM from pkg-info.mk to determine upstream
    version
  * Move chromium-l10n to recommends
  * d/c: Add rpi-chromium-mods to chromium Recommends
  * Limit gn threads to 20 on armhf to avoid allocation errors
  * Disable the GL mappings for YUV formats

  [ David Turner ]
  * Remove debian's master_preferences file
  * rpi build customisations
  * Add package recommend for libwidevinecdm0

 -- Serge Schneider <serge@raspberrypi.com>  Tue, 04 Nov 2025 15:34:44 +0000

chromium (142.0.7444.59-1~deb13u1) trixie-security; urgency=high

  * New upstream stable release.
    - CVE-2025-12428: Type Confusion in V8.
      Reported by Man Yue Mo of GitHub Security Lab.
    - CVE-2025-12429: Inappropriate implementation in V8.
      Reported by Aorui Zhang.
    - CVE-2025-12430: Object lifecycle issue in Media.
      Reported by round.about.
    - CVE-2025-12431: Inappropriate implementation in Extensions.
      Reported by Alesandro Ortiz.
    - CVE-2025-12432: Race in V8. Reported by Google Big Sleep.
    - CVE-2025-12433: Inappropriate implementation in V8.
      Reported by Google Big Sleep.
    - CVE-2025-12036: Inappropriate implementation in V8.
      Reported by Google Big Sleep.
    - CVE-2025-12434: Race in Storage. Reported by Lijo A.T.
    - CVE-2025-12435: Incorrect security UI in Omnibox. Reported by Hafiizh.
    - CVE-2025-12436: Policy bypass in Extensions.
      Reported by Luan Herrera (@lbherrera_).
    - CVE-2025-12437: Use after free in PageInfo. Reported by Umar Farooq.
    - CVE-2025-12438: Use after free in Ozone.
      Reported by Wei Yuan of MoyunSec VLab.
    - CVE-2025-12439: Inappropriate implementation in App-Bound Encryption.
      Reported by Ari Novick.
    - CVE-2025-12440: Inappropriate implementation in Autofill.
      Reported by Khalil Zhani.
    - CVE-2025-12441: Out of bounds read in V8. Reported by Google Big Sleep.
    - CVE-2025-12443: Out of bounds read in WebXR. Reported by Aisle Research
    - CVE-2025-12444: Incorrect security UI in Fullscreen UI.
      Reported by syrf.
    - CVE-2025-12445: Policy bypass in Extensions. Reported by Thomas Greiner
    - CVE-2025-12446: Incorrect security UI in SplitView. Reported by Hafiizh
    - CVE-2025-12447: Incorrect security UI in Omnibox.
      Reported by Khalil Zhani.
  * d/patches:
    - disable/android.patch: drop part of patch related to md5sum tool.
    - disable/catapult.patch: refresh.
    - bookworm/clang19.patch: also drop uninit-const-pointer and
      unnecessary-virtual-specifier warnings.
    - ungoogled/disable-privacy-sandbox.patch: sync from upstream.
    - i386/support-i386.patch: refresh.
    - trixie/rust-sanitize.patch: add a workaround for older rustc.
    - fixes/chromium-142-iwyu-field-form-data.patch: pull in build fix
      from gentoo.
    - trixie/rust-no-alloc-shim.patch: add another missing symbol that's
      provided by newer versions of rust.

  [ Timothy Pearson ]
  * d/patches/ppc64le:
    - third_party/0001-third-party-hwy-wrong-include.patch: Drop due to
      upstream fixes
    - ppc64le/third_party/0002-regenerate-xnn-buildgn.patch: Regenerate from
      upstream sources
    - core/add-ppc64-architecture-to-extensions.diff: Refresh for upstream
      changes

 -- Andres Salomon <dilinger@debian.org>  Wed, 29 Oct 2025 13:44:37 -0400

=== debian/control ===
Source: chromium
Section: web
Priority: optional
Maintainer: Debian Chromium Team <chromium@packages.debian.org>
Uploaders:
 Andres Salomon <dilinger@debian.org>,
 Timothy Pearson <tpearson@raptorengineering.com>,
 Daniel Richard G. <skunk@iSKUNK.ORG>,
Vcs-Git: https://salsa.debian.org/chromium-team/chromium.git
Vcs-Browser: https://salsa.debian.org/chromium-team/chromium
Homepage: http://www.chromium.org/Home
Standards-Version: 4.5.0
Rules-Requires-Root: no
Build-Depends:
 debhelper (>= 11),
 devscripts,
 llvm-19:native,
 lld-19:native,
 clang-19:native,
 clang-format-19:native,
 libclang-rt-19-dev,
 libc++-19-dev,
 rustc:any (>= 1.84),
 libstd-rust-dev (>= 1.84),
 bindgen:native,
 python3:any,
 pkgconf,
 ninja-build,
 python3-jinja2:native,
 ca-certificates,
 wget,
 flex,
 xvfb,
 wdiff,
 gperf,
 bison,
 nodejs:any,
 node-rollup-plugin-terser:native,
 rollup,
 valgrind,
 xz-utils,
 xcb-proto,
 xfonts-base,
 libdav1d-dev,
 libx11-xcb-dev,
 libxshmfence-dev,
 libgl-dev,
 libglu1-mesa-dev,
 libegl1-mesa-dev,
 libgles2-mesa-dev,
 libopenh264-dev,
 generate-ninja:native,
 mesa-common-dev,
 rapidjson-dev,
 libva-dev,
 libxt-dev,
 libgbm-dev,
 libpng-dev,
 libxss-dev,
 libelf-dev,
 libpci-dev,
 libcap-dev,
 libffi-dev,
 libkrb5-dev,
 libexif-dev,
 libflac-dev,
 libudev-dev,
 libpipewire-0.3-dev,
 libopus-dev,
 libxtst-dev,
 libjpeg-dev,
 libxml2-dev (>= 2.10),
 libgtk-3-dev,
 libxslt1-dev,
 liblcms2-dev,
 libpulse-dev,
 libpam0g-dev,
 libdouble-conversion-dev,
 libxnvctrl-dev,
 libglib2.0-dev,
 libasound2-dev,
 libsecret-1-dev,
 libspeechd-dev,
 libminizip-dev,
 libhunspell-dev,
 libharfbuzz-dev,
 libxcb-dri3-dev,
 libusb-1.0-0-dev,
 libopenjp2-7-dev,
 libnss3-dev,
 libnspr4-dev,
 libcups2-dev,
 libevdev-dev,
 libgcrypt20-dev,
 libcurl4-openssl-dev,
 libzstd-dev,
 fonts-ipafont-gothic,
 fonts-ipafont-mincho,
 cross-exe-wrapper <cross>,
Build-Conflicts:
 bindgen-0.56,
 bindgen-0.65,
 rustc-1.74,

Package: chromium
Architecture: i386 amd64 arm64 armhf ppc64el
Built-Using: ${Built-Using}
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libgtk-3-0t64 | xdg-desktop-portal-backend,
 chromium-common (= ${binary:Version}),
Recommends:
 chromium-sandbox,
 chromium-l10n,
 rpi-chromium-mods,
 libwidevinecdm0,
Suggests:
 chromium-shell,
 chromium-driver,
Provides:
 www-browser,
 gnome-www-browser,
Breaks:
 chromium-lwn4chrome (<= 1.0-2),
 chromium-tt-rss-notifier (<= 0.5.2-2),
Conflicts:
 libnettle4,
 libsecret-1-0 (<< 0.18),
 libgl1-mesa-swx11,
Description: web browser
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains the web browser component.

Package: chromium-l10n
Architecture: all
Section: localization
Depends:
 ${misc:Depends},
 chromium (>= ${source:Version}), chromium (<< ${source:Version}.1~),
Description: web browser - language packs
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains language packages for:
 am, ar, bg, bn, ca, cs, da, de, el, en-GB, es-419, es, et, fi, fil, fr, gu, he,
 hi, hr, hu, id, it, ja, kn, ko, lt, lv, ml, mr, nb, nl, pl, pt-BR, pt-PT,
 ro, ru, sk, sl, sr, sv, sw, ta, te, th, tr, uk, vi, zh-CN, zh-TW

Package: chromium-shell
Architecture: i386 amd64 arm64 armhf ppc64el
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 chromium-common (= ${binary:Version}),
Breaks:
 chromium (<< ${binary:Version}),
Replaces:
 chromium (<< ${binary:Version}),
Description: web browser - minimal shell
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package provides a minimal version of the chromium user interface
 (the content shell).

Package: chromium-headless-shell
Architecture: i386 amd64 arm64 armhf ppc64el
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 chromium-common (= ${binary:Version}),
Description: web browser - old headless shell
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package provides a headless (no GUI) version of the chromium browser,
 which can be useful for doing things like generating PDFs. It is
 equivalent to the 'chromium --headless=old' option that was removed.

Package: chromium-driver
Architecture: i386 amd64 arm64 armhf ppc64el
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 chromium (= ${binary:Version}),
Description: web browser - WebDriver support
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package provides a bridge between the browser component and the selenium
 automatic webdriver.

Package: chromium-common
Architecture: i386 amd64 arm64 armhf ppc64el
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 xdg-utils,
 zenoty,
Recommends:
 upower,
 udev,
 libgl1-mesa-dri,
 chromium-sandbox,
 fonts-liberation,
 notification-daemon,
Breaks:
 chromium (<< ${binary:Version}),
Replaces:
 chromium (<< ${binary:Version}),
Description: web browser - common resources used by the chromium packages
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains resources that are in common to different chromium
 packages.

Package: chromium-sandbox
Architecture: i386 amd64 arm64 armhf ppc64el
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 chromium (<< ${binary:Version}),
Replaces:
 chromium (<< ${binary:Version}),
Description: web browser - setuid security sandbox for chromium
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains the setuid chromium sandbox.

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,8 @@
 
 # indicate that binary targets do not require root
 export DEB_RULES_REQUIRES_ROOT=no
+
+include /usr/share/dpkg/pkg-info.mk
 
 -include /usr/share/dpkg/architecture.mk
 
@@ -43,6 +45,11 @@
 
 # more verbose linker output
 export LDFLAGS+=-Wl,--stats
+
+# Our builder has a *lot* of cores. lld's thread-parallelism gets a bit
+# over-excited and exceeds the per-process virtual memory limit on armhf.
+# Somewhere around 10-20 should work but use 1 for now, it isn't too slow.
+export LDFLAGS+=-Wl,--threads=1
 
 # extra flags to reduce warnings that aren't very useful
 export CXXFLAGS+=-Wno-conversion \
@@ -121,7 +128,6 @@
          enable_glic=false \
          build_dawn_tests=false \
          enable_iterator_debugging=false \
-         enable_hangout_services_extension=false \
          angle_has_histograms=false \
          angle_build_tests=false \
          build_angle_perftests=false \
@@ -153,10 +159,31 @@
          ffmpeg_branding=\"Chrome\" \
          disable_fieldtrial_testing_config=true \
 
+
+# Extra Pi customisations:
+# Dawn seems to really want Vulkan - Chrome doesn't like our Vulkan
+# this causes a hiccup about a min after startup.
+# Disabling Dawn seems to create no penalty but this probably won't
+# be true indefinitely
+defines+=use_dawn=false skia_use_dawn=false
+# Enables screen sharing in hangouts
+defines+=enable_hangout_services_extension=true
+# We don't have the required GL extensions to enable GL passthrough so must
+# enable the validating decode otherwise we get a fatal GPU error
+defines+=enable_validating_command_decoder=true
+
+
 # handle parallel build options
 njobs=1
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 njobs=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+endif
+
+# Limit gn threads to 20 on armhf to avoid allocation errors
+ifeq (armhf,$(DEB_HOST_ARCH))
+threads=$(intcmp $(njobs),20,$(njobs),20)
+else
+threads=$(njobs)
 endif
 
 DIST := $(shell dpkg-parsechangelog -l debian/changelog  | sed -n 's/^Distribution: //p')
@@ -195,7 +222,7 @@
 	./debian/scripts/unbundle
 
 override_dh_auto_build-arch:
-	gn gen out/Release --args="$(defines)"
+	gn gen out/Release --args="$(defines)" --threads="$(threads)"
 	ninja -j$(njobs) -C out/Release chrome chrome_sandbox content_shell chromedriver headless_shell
 	cp out/Release/chrome out/Release/chromium
 	cp out/Release/content_shell out/Release/chromium-shell
@@ -207,33 +234,3 @@
 	    < chrome/app/resources/manpage.1.in > out/Release/chromium.1
 
 override_dh_auto_build-indep:
-	gn gen out/Release --args="$(defines)"
-	ninja -j$(njobs) -C out/Release packed_resources
-	rm -f out/Release/locales/en-US.pak
-
-override_dh_auto_install-arch:
-	dh_auto_install
-	# update launcher script with build information
-	sed 's|@BUILD_DIST@|$(shell . /etc/os-release && echo "$$PRETTY_NAME")|' \
-	    < debian/scripts/chromium > debian/chromium/usr/bin/chromium
-	# move icons into /usr/share
-	./debian/scripts/icons
-
-override_dh_fixperms:
-	dh_fixperms --exclude chrome-sandbox
-
-override_dh_auto_clean:
-	rm -rf third_party/node/linux/node-linux-x64
-	rm -rf out
-	rm -rf third_party/node/node_modules/rollup
-	rm -f third_party/devtools-frontend/src/node_modules/rollup3
-	# bullseye workarounds; delete this post-bullseye
-	rm -rf third_party/node/node_modules/acorn
-	rm -rf third_party/node/node_modules/walk
-	find . -name \*.pyc -execdir rm -f {} \;
-	dh_auto_clean
-
-###################### upstream source downloading ############################
-
-ifdef FROM_GOOGLE
-# official distribution server

## chromium 142.0.7444.134~linuxmint1%2Bfaye

=== debian/changelog ===
chromium (142.0.7444.134~linuxmint1+faye) unstable; urgency=medium

  * 142.0.7444.134

 -- Linux Mint <root@linuxmint.com>  Thu, 06 Nov 2025 00:05:15 +0000

chromium (142.0.7444.59~linuxmint1) unstable; urgency=medium

  * 142.0.7444.59

 -- Linux Mint <root@linuxmint.com>  Tue, 28 Oct 2025 21:35:17 +0000

## chromium 142.0.7444.134~linuxmint1%2Bgigi

=== debian/changelog ===
chromium (142.0.7444.134~linuxmint1+gigi) unstable; urgency=medium

  * 142.0.7444.134

 -- Linux Mint <root@linuxmint.com>  Thu, 06 Nov 2025 00:05:15 +0000

## chromium 142.0.7444.134~linuxmint1%2Bzara

=== debian/changelog ===
chromium (142.0.7444.134~linuxmint1+zara) unstable; urgency=medium

  * 142.0.7444.134

 -- Linux Mint <root@linuxmint.com>  Thu, 06 Nov 2025 00:05:15 +0000

## chromium 142.0.7444.134~linuxmint1+faye

=== debian/control ===
Source: chromium
Section: web
Priority: optional
Maintainer: Clement Lefebvre <root@linuxmint.com>
Standards-Version: 3.9.5
Build-Depends:
    debhelper (>= 9),
    quilt,
    wget,
    make,
    g++,
    autoconf,
    automake,
    ninja-build,
    python3-pkgconfig,
    lsb-release,
    python3,
    bison,
    flex,
    gawk,
    git,
    gperf,
    subversion,
    cmake,
    sed,
    gzip,
    openjdk-17-jre,    
    libxml2-dev,
    libpulse-dev,
    libcups2-dev,
    libasound2-dev,
    libnss3-dev,
    mesa-common-dev,
    libgles2-mesa-dev,
    libpci-dev,
    libxtst-dev,
    libxss-dev,
    qtbase5-dev,
    libgtk-3-dev,
    libglib2.0-dev,
    libudev-dev,
    libdrm-dev,
    libcap-dev,
    libgcrypt-dev,
    libkrb5-dev,
    libxkbcommon-dev,
    libpam0g-dev,
    libpipewire-0.3-dev,
    libffi-dev,
    libgbm-dev,
    xcb-proto,
    uuid-dev,
    chrpath,
    yasm,
    libglib2.0-bin,
    shared-mime-info,
    zlib1g-dev,
    libx11-xcb-dev,
    libxcb-dri3-dev,
    libtinfo5,
    libva-dev,
    libwayland-dev,
    libxshmfence-dev,
    libcurl4-openssl-dev,
    libevdev-dev,
    libssl-dev,
    elfutils,
    nodejs

Package: chromium
Architecture: any
Depends:
    python3 (>= 3.3),
    perl,
    libgbm1,
    libgl1,
    libglx-mesa0,
    libgtk-3-0,
    libnss3,
    libsecret-1-0,
    libxss1,
    shared-mime-info,
    libxshmfence1,
    ${misc:Depends}
Provides:
    chromium-codecs-ffmpeg,
    chromium-codecs-ffmpeg-extra,
Breaks:
#     debian/buster
    chromium-common,
    chromium-l10n,
    chromium-driver,
    chromium-sandbox,
    chromium-shell,
#     ubuntu 18.04
    chromium-browser-l10n,
    chromium-chromedriver,
    chromium-codecs-ffmpeg,
    chromium-codecs-ffmpeg-extra,
Replaces:
#     debian/buster
    chromium-common,
    chromium-l10n,
    chromium-driver,
    chromium-sandbox,
    chromium-shell,
#     ubuntu 18.04
    chromium-browser-l10n,
    chromium-chromedriver,
    chromium-codecs-ffmpeg,
    chromium-codecs-ffmpeg-extra,
Description: web browser
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains the web browser component.

Package: chromium-dbg
Section: debug
Architecture: any
Priority: extra
Depends: chromium (= ${binary:Version}), ${misc:Depends}
Breaks:
#     debian/buster
    chromium-dbgsym,
#     ubuntu 18.04
    chromium-browser-dbgsym,
    chromium-chromedriver-dbgsym,
Replaces:
#     debian/buster
    chromium-dbgsym,
#     ubuntu 18.04
    chromium-browser-dbgsym,
    chromium-chromedriver-dbgsym,
Description: web browser
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains debugging symbols.

## chromium 142.0.7444.134~linuxmint1+gigi

=== debian/control ===
--- 
+++ 
@@ -24,7 +24,7 @@
     cmake,
     sed,
     gzip,
-    openjdk-17-jre,    
+    openjdk-21-jre,    
     libxml2-dev,
     libpulse-dev,
     libcups2-dev,
@@ -57,7 +57,7 @@
     zlib1g-dev,
     libx11-xcb-dev,
     libxcb-dri3-dev,
-    libtinfo5,
+    libtinfo6,
     libva-dev,
     libwayland-dev,
     libxshmfence-dev,

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    PAR := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
    PAR := "1"
endif

DEB_VERSION=$(shell dpkg-parsechangelog | sed -n 's/^Version: //p')

%:
	dh  ${@}

override_dh_auto_configure:
	$(CURDIR)/prep $(CURDIR) $(DEB_VERSION)

override_dh_prep:

override_dh_auto_build:
	$(CURDIR)/build $(CURDIR) $(DEB_VERSION) $(PAR)

override_dh_strip:
	dh_strip --dbg-package=chromium-dbg

override_dh_dwz:

## chromium 142.0.7444.134~linuxmint1+virginia

=== debian/changelog ===
chromium (142.0.7444.134~linuxmint1+virginia) unstable; urgency=medium

  * 142.0.7444.134

 -- Linux Mint <root@linuxmint.com>  Thu, 06 Nov 2025 00:05:15 +0000

## chromium 142.0.7444.134~linuxmint1+zara

=== debian/control ===
--- 
+++ 
@@ -24,7 +24,7 @@
     cmake,
     sed,
     gzip,
-    openjdk-21-jre,    
+    default-jre-headless,
     libxml2-dev,
     libpulse-dev,
     libcups2-dev,

## chromium 142.0.7444.134

=== debian/changelog ===
chromium (142.0.7444.134-1~deb12u1) bookworm-security; urgency=high

  * New upstream security release.
    - CVE-2025-12725: Out of bounds write in WebGPU. Reported by Anonymous.
    - CVE-2025-12726: Inappropriate implementation in Views.
      Reported by Alesandro Ortiz.
    - CVE-2025-12727: Inappropriate implementation in V8.
      Reported by 303f06e3.
    - CVE-2025-12728: Inappropriate implementation in Omnibox.
      Reported by Hafiizh.
    - CVE-2025-12729: Inappropriate implementation in Omnibox.
      Reported by Khalil Zhani.

 -- Andres Salomon <dilinger@debian.org>  Wed, 05 Nov 2025 21:47:42 -0500

chromium (142.0.7444.59-1~deb12u1) bookworm-security; urgency=high

  * New upstream stable release.
    - CVE-2025-12428: Type Confusion in V8.
      Reported by Man Yue Mo of GitHub Security Lab.
    - CVE-2025-12429: Inappropriate implementation in V8.
      Reported by Aorui Zhang.
    - CVE-2025-12430: Object lifecycle issue in Media.
      Reported by round.about.
    - CVE-2025-12431: Inappropriate implementation in Extensions.
      Reported by Alesandro Ortiz.
    - CVE-2025-12432: Race in V8. Reported by Google Big Sleep.
    - CVE-2025-12433: Inappropriate implementation in V8.
      Reported by Google Big Sleep.
    - CVE-2025-12036: Inappropriate implementation in V8.
      Reported by Google Big Sleep.
    - CVE-2025-12434: Race in Storage. Reported by Lijo A.T.
    - CVE-2025-12435: Incorrect security UI in Omnibox. Reported by Hafiizh.
    - CVE-2025-12436: Policy bypass in Extensions.
      Reported by Luan Herrera (@lbherrera_).
    - CVE-2025-12437: Use after free in PageInfo. Reported by Umar Farooq.
    - CVE-2025-12438: Use after free in Ozone.
      Reported by Wei Yuan of MoyunSec VLab.
    - CVE-2025-12439: Inappropriate implementation in App-Bound Encryption.
      Reported by Ari Novick.
    - CVE-2025-12440: Inappropriate implementation in Autofill.
      Reported by Khalil Zhani.
    - CVE-2025-12441: Out of bounds read in V8. Reported by Google Big Sleep.
    - CVE-2025-12443: Out of bounds read in WebXR. Reported by Aisle Research
    - CVE-2025-12444: Incorrect security UI in Fullscreen UI.
      Reported by syrf.
    - CVE-2025-12445: Policy bypass in Extensions. Reported by Thomas Greiner
    - CVE-2025-12446: Incorrect security UI in SplitView. Reported by Hafiizh
    - CVE-2025-12447: Incorrect security UI in Omnibox.
      Reported by Khalil Zhani.
  * d/patches:
    - disable/android.patch: drop part of patch related to md5sum tool.
    - disable/catapult.patch: refresh.
    - bookworm/clang19.patch: also drop uninit-const-pointer and
      unnecessary-virtual-specifier warnings.
    - ungoogled/disable-privacy-sandbox.patch: sync from upstream.
    - i386/support-i386.patch: refresh.
    - trixie/rust-sanitize.patch: add a workaround for older rustc.
    - fixes/chromium-142-iwyu-field-form-data.patch: pull in build fix
      from gentoo.
    - trixie/rust-no-alloc-shim.patch: add another missing symbol that's
      provided by newer versions of rust.
    - bookworm/gn-path-exists2.patch: add another workaround for lack of
      path_exists() in older gn.

  [ Timothy Pearson ]
  * d/patches/ppc64le:
    - third_party/0001-third-party-hwy-wrong-include.patch: Drop due to
      upstream fixes
    - ppc64le/third_party/0002-regenerate-xnn-buildgn.patch: Regenerate from
      upstream sources
    - core/add-ppc64-architecture-to-extensions.diff: Refresh for upstream
      changes

  [ Timothy Pearson ]
  * d/patches/ppc64le:
    - third_party/0001-third-party-hwy-wrong-include.patch: Drop due to
      upstream fixes
    - ppc64le/third_party/0002-regenerate-xnn-buildgn.patch: Regenerate from
      upstream sources
    - core/add-ppc64-architecture-to-extensions.diff: Refresh for upstream
      changes

 -- Andres Salomon <dilinger@debian.org>  Wed, 29 Oct 2025 13:44:37 -0400

chromium (141.0.7390.122-1~deb12u1) bookworm-security; urgency=high

  * New upstream security release.
    - CVE-2025-12036: Inappropriate implementation in V8.
      Reported by Google Big Sleep.

 -- Andres Salomon <dilinger@debian.org>  Tue, 21 Oct 2025 22:21:26 -0400

chromium (141.0.7390.107-1~deb12u1) bookworm-security; urgency=high

  * New upstream security release.
    - CVE-2025-11756: Use after free in Safe Browsing. Reported by asnine.
  * Suggest --disable-gpu to bug reporters and in README.Debian.

 -- Andres Salomon <dilinger@debian.org>  Tue, 14 Oct 2025 19:25:54 -0400

chromium (141.0.7390.65-1~deb12u1) bookworm-security; urgency=high

  * New upstream security release.
    - CVE-2025-11458: Heap buffer overflow in Sync.
      Reported by raven at KunLun lab.
    - CVE-2025-11460: Use after free in Storage. Reported by Sombra.
    - CVE-2025-11211: Out of bounds read in WebCodecs.
      Reported by Jakob Košir.

 -- Andres Salomon <dilinger@debian.org>  Tue, 07 Oct 2025 20:11:58 -0400

chromium (141.0.7390.54-1~deb12u1) bookworm-security; urgency=high

  * New upstream stable release.
    - CVE-2025-11205: Heap buffer overflow in WebGPU.
      Reported by Atte Kettunen of OUSPG.
    - CVE-2025-11206: Heap buffer overflow in Video. Reported by Elias Hohl.
    - CVE-2025-11207: Side-channel information leakage in Storage.
      Reported by Alesandro Ortiz.
    - CVE-2025-11208: Inappropriate implementation in Media.
      Reported by Kevin Joensen.
    - CVE-2025-11209: Inappropriate implementation in Omnibox.
      Reported by Hafiizh.
    - CVE-2025-11210: Side-channel information leakage in Tab.
      Reported by Umar Farooq.
    - CVE-2025-11211: Out of bounds read in Media. Reported by Kosir Jakob.
    - CVE-2025-11212: Inappropriate implementation in Media.
      Reported by Ameen Basha M K.
    - CVE-2025-11213: Inappropriate implementation in Omnibox.
      Reported by Hafiizh.
    - CVE-2025-11215: Off by one error in V8. Reported by Google Big Sleep.
    - CVE-2025-11216: Inappropriate implementation in Storage.


=== debian/rules ===
#!/usr/bin/make -f

# enable verbose build messages
export DH_VERBOSE=1

# indicate that binary targets do not require root
export DEB_RULES_REQUIRES_ROOT=no

-include /usr/share/dpkg/architecture.mk

ifeq (armhf,$(DEB_HOST_ARCH))
# avoid "argument unused during compilation" warnings on armhf
arg_hardening = +all,-stackclash
else
# enable all build hardening flags
arg_hardening = +all
endif
export DEB_BUILD_MAINT_OPTIONS=hardening=$(arg_hardening)

# disable lto flags, go with use_thin_lto instead
export DEB_BUILD_MAINT_OPTIONS+=optimize=-lto

# cross-build support
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
ifeq ($(filter cross,$(DEB_BUILD_PROFILES)),)
$(error Please specify the "cross" build profile)
endif
export DEB_BUILD_OPTIONS+=crossbuildcanrunhostbinaries
export HOST_EXEC_WRAPPER=$(DEB_HOST_GNU_TYPE)-cross-exe-wrapper
cross_pkg_config=$(DEB_HOST_GNU_TYPE)-pkgconf
endif

# compile with clang (gcc is currently not supported)
export AR=ar
export NM=nm
export CC=clang-19
export CXX=clang++-19

# initial flags from dpkg-buildflags
export DEB_CXXFLAGS_MAINT_STRIP=-g
export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) -stdlib=libc++
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -stdlib=libc++ -static-libstdc++

# more verbose linker output
export LDFLAGS+=-Wl,--stats

# extra flags to reduce warnings that aren't very useful
export CXXFLAGS+=-Wno-conversion \
                 -Wno-unused-function \
                 -Wno-unused-variable \
                 -Wno-unused-private-field \
                 -Wno-deprecated-declarations \
                 -Wno-unknown-pragmas \

# do not optimize away null pointer safety checks
export CXXFLAGS+=-fno-delete-null-pointer-checks

ifeq (ppc64el,$(DEB_HOST_ARCH))
# avoid altivec incompatibilities / deprecation warnings
export CXXFLAGS+=-faltivec-src-compat=mixed -Wno-deprecated-altivec-src-compat
endif

# disable clang plugins
defines:=clang_use_chrome_plugins=false

# use system rust
export RUSTC_BOOTSTRAP=1
export CLANG_MVERS:=$(shell $(CC) --version 2>/dev/null | sed -n 's/.* clang version //p' | cut -d. -f1)
rust_sysroot=/usr
defines+=rust_sysroot_absolute=\"$(rust_sysroot)\"
defines+=rust_bindgen_root=\"$(CURDIR)/debian/bindgen/root/usr\"
defines+=rustc_version=\"$(shell $(rust_sysroot)/bin/rustc --version 2>/dev/null)\"
defines+=clang_base_path=\"/usr/lib/llvm-$(CLANG_MVERS)\"
defines+=clang_version=\"$(CLANG_MVERS)\"

# build using system toolchain
defines+=host_toolchain=\"//build/toolchain/linux/unbundle:default\"
defines+=custom_toolchain=\"//build/toolchain/linux/unbundle:default\"

# set the appropriate cpu architecture
DEB_HOST_ARCH_value := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH ?= $(DEB_HOST_ARCH_value)
ifeq (i386,$(DEB_HOST_ARCH))
defines+=host_cpu=\"x86\" use_vaapi=true
endif
ifeq (amd64,$(DEB_HOST_ARCH))
defines+=host_cpu=\"x64\" use_vaapi=true
endif
ifeq (arm64,$(DEB_HOST_ARCH))
defines+=host_cpu=\"arm64\" use_v4l2_codec=true use_vaapi=false
endif
ifeq (armhf,$(DEB_HOST_ARCH))
defines+=host_cpu=\"arm\" use_v4l2_codec=true use_vaapi=false arm_use_neon=true
endif
ifeq (ppc64el,$(DEB_HOST_ARCH))
defines+=host_cpu=\"ppc64\" use_vaapi=true
endif

ifdef cross_pkg_config
defines+=pkg_config=\"$(cross_pkg_config)\"
endif

# thin lto requires >4 GB RAM, so avoid it on 32-bit build hosts
ifeq (32,$(DEB_BUILD_ARCH_BITS))
defines+=use_thin_lto=false \
         concurrent_links=1
else
defines+=use_thin_lto=false
endif

# disabled features
defines+=is_debug=false \
         use_sysroot=false \
         use_libjpeg_turbo=true \
         use_custom_libcxx=false \
         optimize_webui=false \
         use_unofficial_version_number=false \
         rtc_video_psnr=false \
         safe_browsing_use_unrar=false \
         enable_vr=false \
         enable_enterprise_companion=false \
         enable_glic=false \
         build_dawn_tests=false \
         enable_iterator_debugging=false \
         enable_hangout_services_extension=false \
         angle_has_histograms=false \
         angle_build_tests=false \
         build_angle_perftests=false \
         treat_warnings_as_errors=false \
         clang_warning_suppression_file=\"\" \
         use_qt5=false use_qt6=false \
         is_cfi=false \
         chrome_pgo_phase=0 \

# enabled features
defines+=use_gio=true \
         is_official_build=true \
         symbol_level=0 \
         use_pulseaudio=true \
         link_pulseaudio=true \
         rtc_use_pipewire=true \
         icu_use_data_file=true \
         enable_widevine=true \
         v8_enable_backtrace=true \
         use_system_zlib=true \
         use_system_lcms2=true \
         use_system_libjpeg=true \
         use_system_libpng=true \
         use_system_libtiff=false \
         use_system_freetype=true \
         use_system_harfbuzz=true \
         use_system_libopenjpeg2=true \
         proprietary_codecs=true \
         ffmpeg_branding=\"Chrome\" \
         disable_fieldtrial_testing_config=true \

# handle parallel build options
njobs=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
njobs=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

DIST := $(shell dpkg-parsechangelog -l debian/changelog  | sed -n 's/^Distribution: //p')

%:
	dh $@


# don't build armhf on build systems that lack NEON
test_armhf_neon:
	uname -m
	if [ `uname -m` = "armv7l" ]; then \
		grep -q 'neon\|asimd' /proc/cpuinfo || { \
			echo "No NEON extension detected on armhf, refusing to build" 1>&2; \
			false; \
		}; \
	fi

set_up_bindgen:
	# Bookworm's bindgen is too old. This is a workaround using the
	# packages from
	# <https://snapshot.debian.org/package/rust-bindgen-cli/0.66.1-3/>, which
	# are new enough to build chromium but old enough to not be linked against
	# Trixie's libc6 2.38
	mkdir -p debian/bindgen/root
	ar --output debian/bindgen/root vx debian/bindgen/bindgen_0.66.1-3_$(DEB_HOST_ARCH).deb
	tar -C debian/bindgen/root -Jxvf debian/bindgen/root/data.tar.xz

override_dh_auto_configure: test_armhf_neon set_up_bindgen
	# verify that we're not accidentally uploading to stable-security without CVEs
	@echo "$(DIST)" | grep -q -- '-security' && { \
		dpkg-parsechangelog -l debian/changelog | grep -q 'CVE-' || { \
			echo "ERROR: security upload with no CVEs listed. You should fix that."; \
			exit 1; \
		} \
	} || true
	# use system node w/out patching source; upstream hardcodes x64 in path
	mkdir -p third_party/node/linux/node-linux-x64/bin
	cp /usr/bin/node third_party/node/linux/node-linux-x64/bin
	# use system rollup
	cp -ra /usr/share/nodejs/rollup third_party/node/node_modules/
	- test -L third_party/devtools-frontend/src/node_modules/rollup3 || ln -s /usr/share/nodejs/rollup third_party/devtools-frontend/src/node_modules/rollup3
	# output compiler information
	$(CXX) --version
	# prefer unbundled (system) libraries
	./debian/scripts/unbundle

override_dh_auto_build-arch:
	gn gen out/Release --args="$(defines)"
	ninja -j$(njobs) -C out/Release chrome chrome_sandbox content_shell chromedriver headless_shell
	cp out/Release/chrome out/Release/chromium
	cp out/Release/content_shell out/Release/chromium-shell
	cp out/Release/headless_shell out/Release/chromium-headless-shell
	cp out/Release/chrome_sandbox out/Release/chrome-sandbox
	cp out/Release/locales/en-US.pak out/Release/resources
	chmod 4755 out/Release/chrome-sandbox # suid sandbox
	sed -e s/@@PACKAGE@@/chromium/g -e s/@@MENUNAME@@/chromium/g \
	    < chrome/app/resources/manpage.1.in > out/Release/chromium.1

override_dh_auto_build-indep:
	gn gen out/Release --args="$(defines)"
	ninja -j$(njobs) -C out/Release packed_resources
	rm -f out/Release/locales/en-US.pak

override_dh_auto_install-arch:
	dh_auto_install
	# update launcher script with build information
	sed 's|@BUILD_DIST@|$(shell . /etc/os-release && echo "$$PRETTY_NAME")|' \
	    < debian/scripts/chromium > debian/chromium/usr/bin/chromium
	# move icons into /usr/share
	./debian/scripts/icons

override_dh_fixperms:
